Index: npl/mailserver/netqmail/roberto-netqmail-1.06.patch-latest
===================================================================
--- npl/mailserver/netqmail/roberto-netqmail-1.06.patch-latest	(revision cd8630be6536b27ae1c762184795ee87723202ab)
+++ npl/mailserver/netqmail/roberto-netqmail-1.06.patch-latest	(revision 1ebb340be23e45ead361b729734f0e82007af6bd)
@@ -3417,5 +3675,5 @@
 diff -ruN ../netqmail-1.06-original/README.rfc2821 netqmail-1.06/README.rfc2821
 --- ../netqmail-1.06-original/README.rfc2821	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/README.rfc2821	2016-11-22 21:03:57.104528366 +0100
++++ netqmail-1.06/README.rfc2821	2019-02-27 20:57:13.380025180 +0100
 @@ -0,0 +1,39 @@
 +This patch is Copyright (C) 2002 - 2003 by Matthias Andree. License below.
@@ -3460,5 +3718,5 @@
 diff -ruN ../netqmail-1.06-original/README.srs netqmail-1.06/README.srs
 --- ../netqmail-1.06-original/README.srs	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/README.srs	2016-11-22 21:03:57.104528366 +0100
++++ netqmail-1.06/README.srs	2019-02-27 20:57:13.381025169 +0100
 @@ -0,0 +1,93 @@
 +qmail SRS patch
@@ -3557,5 +3815,5 @@
 diff -ruN ../netqmail-1.06-original/README.surbl netqmail-1.06/README.surbl
 --- ../netqmail-1.06-original/README.surbl	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/README.surbl	2016-11-22 21:03:57.104528366 +0100
++++ netqmail-1.06/README.surbl	2019-02-27 20:57:13.381025169 +0100
 @@ -0,0 +1,34 @@
 +SURBL filter for netqmail
@@ -3595,5 +3853,5 @@
 diff -ruN ../netqmail-1.06-original/README.tap netqmail-1.06/README.tap
 --- ../netqmail-1.06-original/README.tap	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/README.tap	2016-11-22 21:04:38.822137319 +0100
++++ netqmail-1.06/README.tap	2019-02-27 20:57:13.381025169 +0100
 @@ -0,0 +1,34 @@
 +qmail provides the ability to make a copy of each email that flows through the system.
@@ -3633,10 +3891,10 @@
 diff -ruN ../netqmail-1.06-original/README.tls netqmail-1.06/README.tls
 --- ../netqmail-1.06-original/README.tls	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/README.tls	2016-11-22 21:03:57.104528366 +0100
-@@ -0,0 +1,100 @@
-+Frederik Vermeulen <qmail-tls akrul inoa.net> 20160918
++++ netqmail-1.06/README.tls	2020-01-10 21:46:22.909448586 +0100
+@@ -0,0 +1,98 @@
++Frederik Vermeulen <qmail-tls akrul inoa.net> 20200107
 +http://inoa.net/qmail-tls/
 +
-+This patch implements RFC 3207 (was RFC 2487) in qmail. 
++This patch implements RFC 3207 in qmail. 
 +This means you can get SSL or TLS encrypted and 
 +authenticated SMTP between the MTAs and from MUA to MTA. 
@@ -3644,7 +3902,7 @@
 +many since its first release on 1999-03-21).
 +
-+Usage: - install OpenSSL-1.0.2 http://www.openssl.org/ or later
-+         (any version since 0.9.6 is presumed to work)
-+       - apply patch to netqmail-1.06 http://qmail.org/netqmail
++Usage: - install OpenSSL-1.1.0 http://www.openssl.org/ or later
++         (any version since 0.9.8 is presumed to work)
++       - apply patch to netqmail-1.06 http://www.usenix.org.uk/mirrors/qmail/netqmail
 +         The patches to qmail-remote.c and qmail-smtpd.c can be applied 
 +         separately.
@@ -3709,6 +3967,4 @@
 +         - this patch could conflict with other patches (notably those
 +           replacing \n with \r\n, which is a bad idea on encrypted links).
-+         - some broken servers have a problem with TLSv1 compatibility.
-+           Uncomment the line where we set the SSL_OP_NO_TLSv1 option.
 +         - needs working /dev/urandom (or EGD for openssl versions >0.9.7)
 +           for seeding random number generator.
@@ -3737,5 +3993,5 @@
 diff -ruN ../netqmail-1.06-original/TARGETS netqmail-1.06/TARGETS
 --- ../netqmail-1.06-original/TARGETS	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/TARGETS	2016-11-22 21:04:20.043763470 +0100
++++ netqmail-1.06/TARGETS	2019-06-26 16:45:45.017718421 +0200
 @@ -1,3 +1,4 @@
 +dktest
@@ -3852,5 +4108,5 @@
  qmail-local.0
  qmail-lspawn.0
-@@ -382,6 +415,51 @@
+@@ -382,6 +415,54 @@
  addresses.0
  envelopes.0
@@ -3904,8 +4160,12 @@
 +dknewkey
 +dktest.8
++time_t_size.h
++channels.h
++
 diff -ruN ../netqmail-1.06-original/alloc.c netqmail-1.06/alloc.c
 --- ../netqmail-1.06-original/alloc.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/alloc.c	2016-11-22 21:03:57.105528332 +0100
-@@ -1,6 +1,6 @@
++++ netqmail-1.06/alloc.c	2020-07-27 13:06:47.995674192 +0200
+@@ -1,6 +1,7 @@
++#include <limits.h>
  #include "alloc.h"
  #include "error.h"
@@ -3915,7 +4175,18 @@
  
  #define ALIGNMENT 16 /* XXX: assuming that this alignment is enough */
+@@ -15,6 +16,10 @@
+ unsigned int n;
+ {
+   char *x;
++  if (n >= (INT_MAX >> 3)) {
++    errno = error_nomem;
++    return 0;
++  }
+   n = ALIGNMENT + n - (n & (ALIGNMENT - 1)); /* XXX: could overflow */
+   if (n <= avail) { avail -= n; return space + avail; }
+   x = malloc(n);
 diff -ruN ../netqmail-1.06-original/base64.c netqmail-1.06/base64.c
 --- ../netqmail-1.06-original/base64.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/base64.c	2016-11-22 21:03:57.105528332 +0100
++++ netqmail-1.06/base64.c	2019-02-27 20:57:13.381025169 +0100
 @@ -0,0 +1,124 @@
 +#include "base64.h"
@@ -4045,5 +4316,5 @@
 diff -ruN ../netqmail-1.06-original/base64.h netqmail-1.06/base64.h
 --- ../netqmail-1.06-original/base64.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/base64.h	2016-11-22 21:03:57.105528332 +0100
++++ netqmail-1.06/base64.h	2019-02-27 20:57:13.381025169 +0100
 @@ -0,0 +1,13 @@
 +#ifndef BASE64_H
@@ -4062,5 +4333,5 @@
 diff -ruN ../netqmail-1.06-original/base64sub.c netqmail-1.06/base64sub.c
 --- ../netqmail-1.06-original/base64sub.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/base64sub.c	2016-11-22 21:03:57.105528332 +0100
++++ netqmail-1.06/base64sub.c	2019-02-27 20:57:13.382025158 +0100
 @@ -0,0 +1,170 @@
 +/*
@@ -4236,5 +4507,5 @@
 diff -ruN ../netqmail-1.06-original/byte.h netqmail-1.06/byte.h
 --- ../netqmail-1.06-original/byte.h	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/byte.h	2016-11-22 21:03:57.105528332 +0100
++++ netqmail-1.06/byte.h	2019-02-27 20:57:13.382025158 +0100
 @@ -3,6 +3,8 @@
  
@@ -4248,5 +4519,5 @@
 diff -ruN ../netqmail-1.06-original/byte_cspn.c netqmail-1.06/byte_cspn.c
 --- ../netqmail-1.06-original/byte_cspn.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/byte_cspn.c	2016-11-22 21:03:57.105528332 +0100
++++ netqmail-1.06/byte_cspn.c	2019-02-27 20:57:13.382025158 +0100
 @@ -0,0 +1,11 @@
 +#include "byte.h"
@@ -4263,5 +4534,5 @@
 diff -ruN ../netqmail-1.06-original/byte_rcspn.c netqmail-1.06/byte_rcspn.c
 --- ../netqmail-1.06-original/byte_rcspn.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/byte_rcspn.c	2016-11-22 21:03:57.105528332 +0100
++++ netqmail-1.06/byte_rcspn.c	2019-02-27 20:57:13.382025158 +0100
 @@ -0,0 +1,17 @@
 +#include "byte.h"
@@ -4284,5 +4555,5 @@
 diff -ruN ../netqmail-1.06-original/caldate.h netqmail-1.06/caldate.h
 --- ../netqmail-1.06-original/caldate.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/caldate.h	2016-11-22 21:03:57.105528332 +0100
++++ netqmail-1.06/caldate.h	2019-02-27 20:57:13.382025158 +0100
 @@ -0,0 +1,24 @@
 +/*
@@ -4312,5 +4583,5 @@
 diff -ruN ../netqmail-1.06-original/caltime.h netqmail-1.06/caltime.h
 --- ../netqmail-1.06-original/caltime.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/caltime.h	2016-11-22 21:03:57.105528332 +0100
++++ netqmail-1.06/caltime.h	2019-02-27 20:57:13.382025158 +0100
 @@ -0,0 +1,30 @@
 +/*
@@ -4346,5 +4617,5 @@
 diff -ruN ../netqmail-1.06-original/case_startb.c netqmail-1.06/case_startb.c
 --- ../netqmail-1.06-original/case_startb.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/case_startb.c	2016-11-22 21:03:57.106528299 +0100
++++ netqmail-1.06/case_startb.c	2019-02-27 20:57:13.382025158 +0100
 @@ -0,0 +1,31 @@
 +#include "case.h"
@@ -4379,7 +4650,29 @@
 +}
 +/* end DKIM 1.10 */
+diff -ruN ../netqmail-1.06-original/channels.g netqmail-1.06/channels.g
+--- ../netqmail-1.06-original/channels.g	1970-01-01 01:00:00.000000000 +0100
++++ netqmail-1.06/channels.g	2019-06-26 16:39:31.572826981 +0200
+@@ -0,0 +1,18 @@
++#ifndef CHANNELS_H
++#define CHANNELS_H
++
++/* total number of channels including canonical "local" and "remote" channels */
++#define CHANNELS NUMCHANNELS
++
++/* supplemental channels are all channels less the canonical "local" and "remote" channels */
++#define SUPPL_CHANNELS (CHANNELS - 2)
++
++/* Not longer than 80 bytes, must also change qmail-upq.sh */
++#define QDIR_BASENAME "suppl"
++
++/* start supplemental channel fd numbers here */
++#define CHANNEL_FD_OFFSET 10
++
++
++#endif
++
 diff -ruN ../netqmail-1.06-original/chkspawn.c netqmail-1.06/chkspawn.c
 --- ../netqmail-1.06-original/chkspawn.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/chkspawn.c	2016-11-22 21:03:57.106528299 +0100
++++ netqmail-1.06/chkspawn.c	2019-02-27 20:57:13.382025158 +0100
 @@ -22,8 +22,8 @@
      _exit(1);
@@ -4395,6 +4688,6 @@
 diff -ruN ../netqmail-1.06-original/chkuser.c netqmail-1.06/chkuser.c
 --- ../netqmail-1.06-original/chkuser.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/chkuser.c	2016-11-22 21:04:19.987765257 +0100
-@@ -0,0 +1,1258 @@
++++ netqmail-1.06/chkuser.c	2019-08-05 19:11:16.583873852 +0200
+@@ -0,0 +1,1266 @@
 +
 +/*
@@ -4878,5 +5171,13 @@
 +                } else if (strcasecmp(starting_string, "DOMAIN") == 0) {
 +                        starting_value = 0;
-+                }
++/*
++  Edit by Roberto Puzzanghera
++  It seems like any other definition of starting_string ends up as "DOMAIN".
++  Instead, if starting_string is otherwise defined, we want to turn off chkuser,
++  just like if the starting_string is "NONE".
++ */
++                } else {
++			starting_value = -1;
++		}
 +        } else {
 +                starting_string = "";
@@ -5657,5 +5958,5 @@
 diff -ruN ../netqmail-1.06-original/chkuser.h netqmail-1.06/chkuser.h
 --- ../netqmail-1.06-original/chkuser.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/chkuser.h	2016-11-22 21:03:57.106528299 +0100
++++ netqmail-1.06/chkuser.h	2019-02-27 20:57:13.383025147 +0100
 @@ -0,0 +1,55 @@
 +
@@ -5716,5 +6017,5 @@
 diff -ruN ../netqmail-1.06-original/chkuser_settings.h netqmail-1.06/chkuser_settings.h
 --- ../netqmail-1.06-original/chkuser_settings.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/chkuser_settings.h	2016-11-28 17:35:36.567382036 +0100
++++ netqmail-1.06/chkuser_settings.h	2020-06-16 22:27:56.782600304 +0200
 @@ -0,0 +1,468 @@
 +/*
@@ -5929,5 +6230,5 @@
 + * aliases that have a -default extension
 + */
-+/* #define CHKUSER_ENABLE_ALIAS_DEFAULT */
++#define CHKUSER_ENABLE_ALIAS_DEFAULT
 +
 +
@@ -6080,5 +6381,5 @@
 +
 +/* #define CHKUSER_VAUTH_OPEN_CALL vauth_open   */
-+/* #define CHKUSER_VAUTH_OPEN_CALL vauth_open_update */
++#define CHKUSER_VAUTH_OPEN_CALL vauth_open_update
 +
 +/*
@@ -6100,5 +6401,5 @@
 + *
 + */
-+/* #define CHKUSER_DISABLE_VARIABLE "RELAYCLIENT" */
++#define CHKUSER_DISABLE_VARIABLE "RELAYCLIENT"
 +
 +
@@ -6188,5 +6489,5 @@
 diff -ruN ../netqmail-1.06-original/condredirect.c netqmail-1.06/condredirect.c
 --- ../netqmail-1.06-original/condredirect.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/condredirect.c	2016-11-22 21:03:57.107528266 +0100
++++ netqmail-1.06/condredirect.c	2019-02-27 20:57:13.384025136 +0100
 @@ -10,6 +10,8 @@
  #include "strerr.h"
@@ -6217,18 +6518,26 @@
 diff -ruN ../netqmail-1.06-original/conf-cc netqmail-1.06/conf-cc
 --- ../netqmail-1.06-original/conf-cc	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/conf-cc	2016-11-22 21:03:57.107528266 +0100
++++ netqmail-1.06/conf-cc	2020-01-10 21:52:13.080721081 +0100
 @@ -1,3 +1,3 @@
 -cc -O2
-+cc -O2 -g -DEXTERNAL_TODO -DTLS=20160918 -I/usr/local/ssl/include -I/home/vpopmail/include
++cc -O2 -g -DEXTERNAL_TODO -DTLS=20200107 -I/usr/local/ssl/include -I/home/vpopmail/include
  
  This will be used to compile .c files.
+diff -ruN ../netqmail-1.06-original/conf-channels netqmail-1.06/conf-channels
+--- ../netqmail-1.06-original/conf-channels	1970-01-01 01:00:00.000000000 +0100
++++ netqmail-1.06/conf-channels	2019-06-26 19:12:46.033685227 +0200
+@@ -0,0 +1,4 @@
++2
++
++Total number of channels (queues) available for delivery. Must be at
++least 2, and anything above 2 are considered supplemental channels.
 diff -ruN ../netqmail-1.06-original/conf-domainkeys netqmail-1.06/conf-domainkeys
 --- ../netqmail-1.06-original/conf-domainkeys	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/conf-domainkeys	2016-11-22 21:03:57.107528266 +0100
++++ netqmail-1.06/conf-domainkeys	2019-02-27 20:57:13.384025136 +0100
 @@ -0,0 +1 @@
 +-DDOMAIN_KEYS
 diff -ruN ../netqmail-1.06-original/conf-ld netqmail-1.06/conf-ld
 --- ../netqmail-1.06-original/conf-ld	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/conf-ld	2016-11-22 21:03:57.107528266 +0100
++++ netqmail-1.06/conf-ld	2019-02-27 20:57:13.384025136 +0100
 @@ -1,3 +1,3 @@
 -cc -s
@@ -6238,5 +6547,5 @@
 diff -ruN ../netqmail-1.06-original/conf-policy netqmail-1.06/conf-policy
 --- ../netqmail-1.06-original/conf-policy	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/conf-policy	2016-11-22 21:03:57.107528266 +0100
++++ netqmail-1.06/conf-policy	2019-02-27 20:57:13.384025136 +0100
 @@ -0,0 +1,17 @@
 +-DPOLICY_FILENAME="/var/qmail/control/policy" -DPOLICY_DEALLOCATE -DPOLICY_ENFORCE_AUTHENTICATION
@@ -6259,5 +6568,5 @@
 diff -ruN ../netqmail-1.06-original/conf-spawn netqmail-1.06/conf-spawn
 --- ../netqmail-1.06-original/conf-spawn	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/conf-spawn	2016-11-22 21:03:57.108528232 +0100
++++ netqmail-1.06/conf-spawn	2019-02-27 20:57:13.384025136 +0100
 @@ -1,4 +1,4 @@
 -120
@@ -6268,5 +6577,5 @@
 diff -ruN ../netqmail-1.06-original/config.h netqmail-1.06/config.h
 --- ../netqmail-1.06-original/config.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/config.h	2016-11-22 21:03:57.108528232 +0100
++++ netqmail-1.06/config.h	2019-02-27 20:57:13.384025136 +0100
 @@ -0,0 +1,10 @@
 +/* config.h.  Generated from config.h.in by configure.  */
@@ -6282,5 +6591,5 @@
 diff -ruN ../netqmail-1.06-original/control.c netqmail-1.06/control.c
 --- ../netqmail-1.06-original/control.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/control.c	2016-11-22 21:03:57.108528232 +0100
++++ netqmail-1.06/control.c	2019-02-27 20:57:13.384025136 +0100
 @@ -85,6 +85,82 @@
   return 1;
@@ -6368,5 +6677,5 @@
 diff -ruN ../netqmail-1.06-original/control.h netqmail-1.06/control.h
 --- ../netqmail-1.06-original/control.h	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/control.h	2016-11-22 21:03:57.108528232 +0100
++++ netqmail-1.06/control.h	2019-02-27 20:57:13.384025136 +0100
 @@ -3,8 +3,10 @@
  
@@ -6382,5 +6691,5 @@
 diff -ruN ../netqmail-1.06-original/date822fmt.c netqmail-1.06/date822fmt.c
 --- ../netqmail-1.06-original/date822fmt.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/date822fmt.c	2016-11-22 21:03:57.108528232 +0100
++++ netqmail-1.06/date822fmt.c	2019-02-27 20:57:13.385025125 +0100
 @@ -1,3 +1,4 @@
 +#include <time.h>
@@ -6449,6 +6758,6 @@
 diff -ruN ../netqmail-1.06-original/dk-filter.9 netqmail-1.06/dk-filter.9
 --- ../netqmail-1.06-original/dk-filter.9	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/dk-filter.9	2016-11-22 21:03:57.108528232 +0100
-@@ -0,0 +1,102 @@
++++ netqmail-1.06/dk-filter.9	2020-04-10 11:08:43.313802048 +0200
+@@ -0,0 +1,98 @@
 +.TH dk-filter 8
 +.SH NAME
@@ -6472,7 +6781,7 @@
 +It uses the libdkim and OpenSSL libraries.  To sign a message, set the
 +.B DKIMSIGN
-+or
-+.B DKSIGIN
-+environment variables to the pathname of the private key that will be
++environment variable (for DKIM signing) or
++.B DKSIGN
++environment variable (for DK signing) to the pathname of the private key that will be
 +used to sign the message. If there is a % character in the environment
 +variable, it is removed and replaced by the domain name in the From: header.
@@ -6482,4 +6791,7 @@
 +After all substitutions, if the key file does not exist, the message will not be signed.
 +If there is no % and the file does not exist, the message will be rejected with error 35.
++The default private key QMAILHOME/control/domainkeys/default can be overriden by the
++\fBDKIM_DEFAULT_KEY\fR environment variable.
++
 +The selector (s=) will be taken from the basename of the file.
 +The private key should be created by 
@@ -6519,29 +6831,22 @@
 +.EE
 +
-+.B dk-filter
-+uses the domain found in the Sender: header to set the domain tag. If not it uses the From: header. You can override this by
-+setting 
-+.B DKIMDOMAIN
-+environment variable.
-+.B DKIMDOMAIN
-+can be set to an email address or a domain (without the at sign).
-+To verify a message, set the
-+.B DKIMVERIFY
-+or
-+.B DKVERIFY
-+environment variables
-+.B dk-filter
-+always inserts the 
-+.B DKIM-Status
-+or
-+.B DomainKey-Status
-+header, so that messages can be
-+rejected later at delivery time, or in the mail reader. In that case you may set
-+.B DKIMVERIFY
-+or
-+.B DKVERIFY
-+to an empty string.
-+.B dk-filter
-+does not use any signing practice byd default. You can override this by setting the SIGN_PRACTICE to ssp or adsp (lowercase).
++when signing \fBdk-filter\fR uses the domain found in the Return-Path, Sender, From headers to set
++the domain tag. If not it uses the value of \fBDKIMDOMAIN\fR environment
++variable. \fBDKIMDOMAIN\fR can be set to an email address or a domain (without the at sign).
++
++To verify a message, set the \fBDKIMVERIFY\fR or \fBDKVERIFY\fR environment variables.
++\fBdk-filter\fR always inserts the \fBDKIM-Status\fR or \fBDomainKey-Status\fR header, so
++that messages can be rejected later at delivery time, or in the mail reader. In that case
++you may set \fBDKIMVERIFY\fR or \fBDKVERIFY\fR to an empty string. The exit code of \fBdk-filter\fR
++can be fine tuned by setting \fBDKIMVERIFY\fR environment variable. See \fBdkim(8)\fR for a detailed
++description on setting the \fBDKIMVERIFY\fR environment variable.
++
++\fBdk-filter\fR does not use any signing practice by default. You can override this by setting
++the \fBSIGN_PRACTICE\fR to ssp or adsp (lowercase).
++
++If neither of these environment variables (\fBDKIMSIGN\fR, \fBDKSIGN\fR, \fBDKIMVERIFY\fR, \fBDKVERIFY\fR) are defined, \fBdk-filter\fR
++will do signing by default.
++
++You can set environment variable \fBNODK\fR to disable domainkeys and \fBNODKIM\fR to disable \fBDKIM\fR.
 +
 +.SH "EXIT CODES"
@@ -6555,8 +6860,32 @@
 diff -ruN ../netqmail-1.06-original/dk-filter.sh netqmail-1.06/dk-filter.sh
 --- ../netqmail-1.06-original/dk-filter.sh	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/dk-filter.sh	2016-11-22 21:03:57.109528199 +0100
-@@ -0,0 +1,315 @@
++++ netqmail-1.06/dk-filter.sh	2020-07-29 15:59:13.351023490 +0200
+@@ -0,0 +1,367 @@
 +#
 +# $Log: dk-filter.sh,v $
++# Revision 1.22  2019-06-24 23:19:57+05:30  Cprogrammer
++# added code for -d option in DKIMSIGNOPTIONS
++#
++# Revision 1.21  2019-01-14 00:10:00+05:30  Cprogrammer
++# added -S, -f option to verify signatures with unsigned subject, unsigned from
++#
++# Revision 1.20  2017-03-09 16:38:15+05:30  Cprogrammer
++# FHS changes
++#
++# Revision 1.19  2016-05-17 23:11:42+05:30  Cprogrammer
++# fix for configurable control directory
++#
++# Revision 1.18  2014-03-12 08:50:48+05:30  Cprogrammer
++# bug - fixed signing when env variables DKSIGN or DKIMSIGN were set
++#
++# Revision 1.17  2013-09-03 23:04:30+05:30  Cprogrammer
++# set signing as default if both DKSIGN and DKIMSIGN are not defined
++#
++# Revision 1.16  2013-08-17 15:59:21+05:30  Cprogrammer
++# do not treat duplicate DomainKey-Signature as an error
++#
++# Revision 1.15  2013-08-17 15:02:06+05:30  Cprogrammer
++# fixed syntax errors and private key lookup
++#
 +# Revision 1.14  2011-02-10 22:47:01+05:30  Cprogrammer
 +# fixed exit code of dk-filter when doing verification
@@ -6604,5 +6933,5 @@
 +# Initial revision
 +#
-+# $Id: dk-filter.sh,v 1.14 2011-02-10 22:47:01+05:30 Cprogrammer Stab mbhangui $
++# $Id: dk-filter.sh,v 1.22 2019-06-24 23:19:57+05:30 Cprogrammer Exp mbhangui $
 +#
 +if [ -z "$QMAILREMOTE" -a -z "$QMAILLOCAL" ]; then
@@ -6614,13 +6943,26 @@
 +dkverify=0
 +dkimverify=0
-+if [ -z "$DKSIGN" -a -z "$DKVERIFY" ] ; then
-+	DKSIGN=QMAILHOME/control/domainkeys/%/default
-+	dksign=2
++if [ -z "$DEFAULT_DKIM_KEY" ] ; then
++	default_key=QMAILHOME/control/domainkeys/default
++else
++	default_key=$DEFAULT_DKIM_KEY
 +fi
-+if [ -z "$DKIMSIGN" -a -z "$DKIMVERIFY" ] ; then
-+	DKIMSIGN=QMAILHOME/control/domainkeys/%/default
-+	dkimsign=2
++if [ -z "$NODK" -a -x QMAILHOME/bin/dktest -a -z "$DKVERIFY" ] ; then
++	if [ -z "$DKSIGN" ] ; then
++		DKSIGN=QMAILHOME/control/domainkeys/%/default
++		dksign=2
++	elif [ " $DKSIGN" = " QMAILHOME/control/domainkeys/%/default" ] ; then
++		dksign=2
++	fi
 +fi
-+if [ ! -z "$DKSIGN" ] ; then
++if [ -z "$NODKIM" -a -x QMAILHOME/bin/dkim -a -z "$DKIMVERIFY" ] ; then
++	if [ -z "$DKIMSIGN" ] ; then
++		DKIMSIGN=QMAILHOME/control/domainkeys/%/default
++		dkimsign=2
++	elif [ " $DKIMSIGN" = " QMAILHOME/control/domainkeys/%/default" ] ; then
++		dkimsign=2
++	fi
++fi
++if [ -z "$NODK" -a -n "$DKSIGN" ] ; then
 +	if [ ! -f QMAILHOME/bin/dktest ] ; then
 +		echo "QMAILHOME/bin/dktest: No such file or directory" 1>&2
@@ -6632,5 +6974,7 @@
 +		percent_found=1
 +	fi
-+	if [ ! " $_SENDER" = " " ] ; then
++	if [ -n "$DKIMDOMAIN" ] && [ -z "$_SENDER" ] ; then
++		dkkeyfn=`echo $DKSIGN | sed s{%{$DKIMDOMAIN{g`
++	elif [ ! " $_SENDER" = " " ] ; then
 +		# replace '%' in filename with domain
 +		domain=`echo $_SENDER | cut -d@ -f2`
@@ -6640,5 +6984,5 @@
 +	fi
 +	if [ $dksign -eq 2 -a ! -f $dkkeyfn ] ; then
-+		dkkeyfn=QMAILHOME/control/domainkeys/default
++		dkkeyfn=$default_key
 +	fi
 +	if [ -f $dkkeyfn ] ; then
@@ -6652,5 +6996,5 @@
 +	dkselector=`basename $dkkeyfn`
 +fi
-+if [ ! -z "$DKIMSIGN" ] ; then
++if [ -z "$NODKIM" -a -n "$DKIMSIGN" ] ; then
 +	if [ ! -f QMAILHOME/bin/dkim ] ; then
 +		echo "QMAILHOME/bin/dkim: No such file or directory" 1>&2
@@ -6662,5 +7006,7 @@
 +		percent_found=1
 +	fi
-+	if [ ! " $_SENDER" = " " ] ; then
++	if [ -n "$DKIMDOMAIN" ] && [ -z "$_SENDER" ] ; then
++		dkimkeyfn=`echo $DKIMSIGN | sed s{%{$DKIMDOMAIN{g`
++	elif [ ! " $_SENDER" = " " ] ; then
 +		# replace '%' in filename with domain
 +		domain=`echo $_SENDER | cut -d@ -f2`
@@ -6670,5 +7016,5 @@
 +	fi
 +	if [ $dkimsign -eq 2 -a ! -f $dkimkeyfn ] ; then
-+		dkimkeyfn=QMAILHOME/control/domainkeys/default
++		dkimkeyfn=$default_key
 +	fi
 +	if [ -f $dkimkeyfn ] ; then
@@ -6678,9 +7024,9 @@
 +	fi
 +	if [ $dkimsign -eq 0 -a $percent_found -ne 1 ] ; then
-+		exit 32
++		exit 32 # private key does not exist
 +	fi
 +	dkimselector=`basename $dkimkeyfn`
 +fi
-+if [ ! -z "$DKVERIFY" ] ; then
++if [ -z "$NODK" -a -n "$DKVERIFY" ] ; then
 +	if [ ! -f QMAILHOME/bin/dktest ] ; then
 +		echo "QMAILHOME/bin/dktest: No such file or directory" 1>&2
@@ -6689,5 +7035,5 @@
 +	dkverify=1
 +fi
-+if [ ! -z "$DKIMVERIFY" ] ; then
++if [ -z "$NODKIM" -a -n "$DKIMVERIFY" ] ; then
 +	if [ ! -f QMAILHOME/bin/dkim ] ; then
 +		echo "QMAILHOME/bin/dkim: No such file or directory" 1>&2
@@ -6730,4 +7076,9 @@
 +		-c)
 +		dkimopts="$dkimopts -c $2"
++		shift
++		;;
++
++		-d)
++		dkimopts="$dkimopts -d $2"
 +		shift
 +		;;
@@ -6824,9 +7175,8 @@
 +	fi
 +	exec 0</tmp/dk.$$
-+	#QMAILHOME/bin/dktest -h -s $dkkeyfn
 +	eval $dkopts
 +	exit_val=$?
 +	# allow error due to duplicate DomainKey-Header
-+	if [ $exit_val -ne 0 -a $exit_val -ne 6 ] ; then
++	if [ $exit_val -ne 0 -a $exit_val -ne 12 ] ; then
 +		/bin/rm -f /tmp/dk.$$
 +		exit $exit_val
@@ -6843,5 +7193,12 @@
 +	fi
 +	exec 0</tmp/dk.$$
-+	QMAILHOME/bin/dkim -p $practice -v
++	dkimvargs="-p $practice"
++	if [ -n "$UNSIGNED_SUBJECT" ] ; then
++		dkimvargs="$dkimvargs -S"
++	fi
++	if [ -n "$UNSIGNED_FROM" ] ; then
++		dkimvargs="$dkimvargs -f"
++	fi
++	QMAILHOME/bin/dkim $dkimvargs -v
 +	ret=$?
 +	case $ret in
@@ -6874,6 +7231,6 @@
 diff -ruN ../netqmail-1.06-original/dkim.9 netqmail-1.06/dkim.9
 --- ../netqmail-1.06-original/dkim.9	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/dkim.9	2018-04-03 14:46:51.362411599 +0200
-@@ -0,0 +1,98 @@
++++ netqmail-1.06/dkim.9	2020-04-09 19:43:56.494473495 +0200
+@@ -0,0 +1,108 @@
 +.TH dkim 8
 +.SH NAME
@@ -6892,5 +7249,5 @@
 +
 +.EX
-+ (./dkim -s QMAILHOME/control/domainkeys/dog </tmp/testmsg; cat /tmp/testmsg)\
++ (./dkim -s INDIMAIL/control/domainkeys/dog </tmp/testmsg; cat /tmp/testmsg)\
 + | ./dkim -v
 +.EE
@@ -6924,5 +7281,5 @@
 +.TP
 +-l
-+include body length tag
++include body length tag when signing. Honor body length tag when verifying
 +.TP
 +-q
@@ -6934,4 +7291,7 @@
 +-f
 +issue error if not all message's From headers are in signature
++.TP
++-S
++Allow unsigned subject in signature
 +.TP
 +-h
@@ -6946,6 +7306,8 @@
 +-c \fIcanonicalization\fR
 +r for relaxed [DEFAULT], s - simple, t relaxed/simple, u - simple/relaxed
++
++.TP
 +-d \fIdomain\fR
-+the domain tag, if not provided, determined from the sender/from header
++the domain tag, if not provided, determined from the return-path/sender/from header
 +.TP
 +-i \fIidentity\fR
@@ -6967,4 +7329,9 @@
 +this help
 +
++.SH Return Value
++When signing, \fBdkim\fR returns 0 on success and non-zero on any failure. For verification, you can set the
++environment varable \fBDKIMVERIFY\fR. Refer to qmail-dkim(8) for a full description of  the \fBDKIMVERIFY\fR
++environment variable
++
 +.SH "SEE ALSO"
 +dktest(8),
@@ -6976,8 +7343,20 @@
 diff -ruN ../netqmail-1.06-original/dkim.c netqmail-1.06/dkim.c
 --- ../netqmail-1.06-original/dkim.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/dkim.c	2018-04-03 14:46:51.363411603 +0200
-@@ -0,0 +1,899 @@
++++ netqmail-1.06/dkim.c	2019-06-19 09:46:59.689809564 +0200
+@@ -0,0 +1,871 @@
 +/*
 + * $Log: dkim.c,v $
++ * Revision 1.23  2019-06-14 21:24:59+05:30  Cprogrammer
++ * BUG - honor body length tag in verification
++ *
++ * Revision 1.22  2019-01-13 10:10:27+05:30  Cprogrammer
++ * added missing usage string for allowing unsigned subject.
++ *
++ * Revision 1.21  2018-08-08 23:57:02+05:30  Cprogrammer
++ * issue success if at lease one one good signature is found
++ *
++ * Revision 1.20  2018-05-22 10:03:26+05:30  Cprogrammer
++ * changed return type of writeHeader() to void
++ *
 + * Revision 1.19  2016-03-01 16:23:38+05:30  Cprogrammer
 + * added -S option to allow email with unsigned subject
@@ -7109,4 +7488,6 @@
 +	fprintf(stderr, "t                    include a timestamp tag\n");
 +	fprintf(stderr, "h                    include Copied Headers\n");
++	fprintf(stderr, "f                    allow Unsigned From (default is to reject if From field is not signed)\n");
++	fprintf(stderr, "S                    allow Unsigned Subject (default is to reject if Subject field is not signed)\n");
 +	fprintf(stderr, "v                    verify the message\n");
 +	fprintf(stderr, "p <ssp|adsp>         0 - disable practice (default), 1- SSP, or 2 - ADSP verification\n");
@@ -7120,8 +7501,7 @@
 +	fprintf(stderr, "z <hash>             1 for sha1, 2 for sha256, 3 for both\n");
 +#endif
-+	fprintf(stderr, "f                    0 = From headers not included in the signature are not allowed\n");
-+	fprintf(stderr, "                     1 = allowed\n");
 +	fprintf(stderr, "y <selector>         the selector tag DEFAULT=private\n");
 +	fprintf(stderr, "s <privkeyfile>      sign the message using the private key in privkeyfile\n");
++	fprintf(stderr, "V                    set verbose mode\n");
 +	fprintf(stderr, "H                    this help\n");
 +	exit(1);
@@ -7135,6 +7515,5 @@
 +	ch = c;
 +	t = s;
-+	for (;;)
-+	{
++	for (;;) {
 +		if (!*t)
 +			break;
@@ -7187,5 +7566,5 @@
 + * Allows you to add the headers contain the results and DKIM ADSP
 + */
-+int writeHeader(int ret, int resDKIMSSP, int resDKIMADSP, int useSSP, int useADSP )
++void writeHeader(int ret, int resDKIMSSP, int resDKIMADSP, int useSSP, int useADSP )
 +{
 +	char           *dkimStatus, *sspStatus, *adspStatus;
@@ -7286,6 +7665,5 @@
 +		}
 +	}
-+	if (useADSP && resDKIMADSP != -1)
-+	{
++	if (useADSP && resDKIMADSP != -1) {
 +		switch(resDKIMADSP)
 +		{
@@ -7325,22 +7703,16 @@
 +		values[i] = 0;
 +	key = 0;
-+	for(ptr = list;*ptr;)
-+	{
++	for(ptr = list;*ptr;) {
 +		if ((*ptr == ' ') || (*ptr == '\t') || (*ptr == '\r') || (*ptr == '\n')) /*- FWS */
 +			*ptr++ = 0;
 +		if (!key)
 +			key = ptr;
-+		if (*ptr == '=')
-+		{
++		if (*ptr == '=') {
 +			*ptr = 0;
-+			for (i = 0;letters[i];i++)
-+			{
-+				if (!strcmp(letters[i], key))
-+				{
++			for (i = 0;letters[i];i++) {
++				if (!strcmp(letters[i], key)) {
 +					ptr++;
-+					for (;*ptr;)
-+					{
-+						if ((*ptr == ' ') || (*ptr == '\t') || (*ptr == '\r') || (*ptr == '\n'))
-+						{
++					for (;*ptr;) {
++						if ((*ptr == ' ') || (*ptr == '\t') || (*ptr == '\r') || (*ptr == '\n')) {
 +							ptr++;
 +							continue;
@@ -7353,8 +7725,6 @@
 +					if (*ptr)
 +						*ptr++ = 0;
-+					for(;tmp != values[i];tmp--) /*- RFC 4871 3.2 */
-+					{
-+						if ((*tmp == ' ') || (*tmp == '\t') || (*tmp == '\r') || (*tmp == '\n'))
-+						{
++					for(;tmp != values[i];tmp--) /*- RFC 4871 3.2 */ {
++						if ((*tmp == ' ') || (*tmp == '\t') || (*tmp == '\r') || (*tmp == '\n')) {
 +							*tmp = 0;
 +							continue;
@@ -7381,6 +7751,5 @@
 +
 +	*bTesting = 0;
-+	if (!(query = (char *) DKIM_MALLOC(strlen("_ssp._domainkey.") + strlen(domain) + 1)))
-+	{
++	if (!(query = (char *) DKIM_MALLOC(strlen("_ssp._domainkey.") + strlen(domain) + 1))) {
 +		fprintf(stderr, "malloc: %d: %s\n", strlen("_ssp._domainkey.") + strlen(domain) + 1,
 +			strerror(errno));
@@ -7390,20 +7759,16 @@
 +	results = dns_text(query);
 +	DKIM_MFREE(query);
-+	if (!strcmp(results, "e=temp;"))
-+	{
++	if (!strcmp(results, "e=temp;")) {
 +		DKIM_MFREE(results);
 +		return DKIM_SSP_TEMPFAIL;
 +	} else
-+	if (!strcmp(results, "e=perm;"))
-+	{
++	if (!strcmp(results, "e=perm;")) {
 +		DKIM_MFREE(results);
 +		results = dns_text(domain);
-+		if (!strcmp(results, "e=temp;"))
-+		{
++		if (!strcmp(results, "e=temp;")) {
 +			DKIM_MFREE(results);
 +			return DKIM_SSP_TEMPFAIL;
 +		} else
-+		if (!strcmp(results, "e=perm;"))
-+		{
++		if (!strcmp(results, "e=perm;")) {
 +			DKIM_MFREE(results);
 +			return DKIM_SSP_SCOPE;
@@ -7411,6 +7776,5 @@
 +		bIsParentSSP = 1;
 +	}
-+	if (!ParseTagValues(results, tags, values))
-+	{
++	if (!ParseTagValues(results, tags, values)) {
 +		DKIM_MFREE(results);
 +		return DKIM_SSP_UNKNOWN;
@@ -7427,6 +7791,5 @@
 +	if (values[1] != NULL) {
 +		char           *s, *p;
-+		for (p = values[1], s = values[1]; *p; p++)
-+		{
++		for (p = values[1], s = values[1]; *p; p++) {
 +			if (*p == '|')
 +				*p = 0;
@@ -7460,16 +7823,13 @@
 +
 +	results = dns_text(domain);
-+	if (!strcmp(results, "e=perm;"))
-+	{
++	if (!strcmp(results, "e=perm;")) {
 +		DKIM_MFREE(results);
 +		return DKIM_ADSP_SCOPE;
 +	} else
-+	if (!strcmp(results, "e=temp;"))
-+	{
++	if (!strcmp(results, "e=temp;")) {
 +		DKIM_MFREE(results);
 +		return DKIM_ADSP_TEMPFAIL;
 +	}
-+	if (!(query = (char *) DKIM_MALLOC(strlen((char *) "_adsp._domainkey.") + strlen(domain) + 1)))
-+	{
++	if (!(query = (char *) DKIM_MALLOC(strlen((char *) "_adsp._domainkey.") + strlen(domain) + 1))) {
 +		fprintf(stderr, "malloc: %d: %s\n", strlen("_adsp._domainkey.") + strlen(domain) + 1,
 +			strerror(errno));
@@ -7479,16 +7839,13 @@
 +	results = dns_text(query);
 +	DKIM_MFREE(query);
-+	if (!strcmp(results, "e=perm;"))
-+	{
++	if (!strcmp(results, "e=perm;")) {
 +		DKIM_MFREE(results);
 +		return DKIM_ADSP_SCOPE;
 +	} else
-+	if (!strcmp(results, "e=temp;"))
-+	{
++	if (!strcmp(results, "e=temp;")) {
 +		DKIM_MFREE(results);
 +		return DKIM_ADSP_TEMPFAIL;
 +	}
-+	if (!ParseTagValues(results, tags, values))
-+	{
++	if (!ParseTagValues(results, tags, values)) {
 +		DKIM_MFREE(results);
 +		return DKIM_ADSP_UNKNOWN;
